import { IacFileParsed, IacFileParseFailure, IaCTestFlags, SafeAnalyticsOutput, TestReturnValue, IacOrgSettings } from './types';
import { CustomError } from '../../../../lib/errors';
export declare function test(pathToScan: string, options: IaCTestFlags): Promise<TestReturnValue>;
export declare function removeFileContent({ filePath, fileType, failureReason, projectType, }: IacFileParsed | IacFileParseFailure): SafeAnalyticsOutput;
/**
 * Pull and store the IaC custom-rules bundle from the remote OCI Registry.
 */
export declare function pullIaCCustomRules(iacOrgSettings: IacOrgSettings): Promise<void>;
export declare class FailedToPullCustomBundleError extends CustomError {
    constructor(message?: string);
}
export declare class FailedToExecuteCustomRulesError extends CustomError {
    constructor(message?: string);
}
